#include "Korisnik.h"

Korisnik::Korisnik(const Broj& broj_telefona) : broj_telefona_(broj_telefona) {}

Korisnik::~Korisnik() {
	// Napredna for petlja
	// U svakoj iteraciji iz vektora 'usluge_' dohvata se jedan element (Usluga*) i dodeljuje iteratoru petlje 'usluga'
	for (Usluga* usluga : usluge_) {
		delete usluga;
	}
}

void Korisnik::evidentirajPoziv(const Broj& broj_ka, int trajanje) {
	usluge_.push_back(new Poziv(broj_telefona_, broj_ka, trajanje));
	cout << "Uspesno evidentiran poziv: ";
	usluge_.back()->pisi();
	cout << endl;
}

void Korisnik::evidentirajPoruku(const Broj& broj_ka, const string& tekst) {
	try {
		// S obzirom da pozivamo konstruktor Poruke koji moze da baci izuzetak, moramo da obezbedimo hvatanje i obradu izuzetka ili da pustimo da se izuzetak prosledi van ove metode pa da neko drugi brine o tome
		usluge_.push_back(new Poruka(broj_telefona_, broj_ka, tekst));
		// Deo koda ispod se nece ni desiti ukoliko je bacen izuzetak
		cout << "Uspesno evidentirana poruka: ";
		usluge_.back()->pisi();
		cout << endl;
	}
	catch (NeuspesnoPoslataPoruka& e) { 
		// Izuzetak je uhvacen i prosto ispisujemo poruku na ekran
		// Operacija 'evidentirajPoruku' ostaje bez efekta sto je ono sto smo i hteli u slucaju izuzetka
		cout << e.what() << endl; 
	}
}

void Korisnik::pisi() const {
	cout << "Evidencija usluga:" << endl << "Korisnik: ";
	broj_telefona_.pisi();
	cout << endl;
	double ukupna_cena = 0;
	for (Usluga* usluga : usluge_) {
		usluga->pisi();
		cout << endl;
		ukupna_cena += usluga->cena();
	}
	cout << "Ukupna cena usluga: " << ukupna_cena;
}
