#ifndef USLUGE_H
#define USLUGE_H

// Praksa je da se prvo navode korisnicki fajlovi i biblioteke, a tek onda ugradjene
#include "Broj.h"
#include "Exceptions.h"
#include <iostream>
#include <string>
using namespace std;

// U redu je da klase koje su u istoj hijerarhiji nasledjivanja budu definisane u istom .h fajlu

class Usluga {
public:
	Usluga(const Broj&, const Broj&);

	virtual double cena() const = 0;
	virtual void pisi() const;

protected:
	Broj broj_od_;
	Broj broj_ka_;
};

// Uvedene simbolicke konstante
const int uspostavljanjeVezeDom = 0;
const int uspostavljanjeVezeIno = 30;
const int zapocetiMinutDom = 10;
const int zapocetiMinutIno = 50;

class Poziv : public Usluga {
public:
	// Moramo da predvidimo konstruktor klase Poziv koji sadrzi prosledjene brojeve kako bismo na ispravan nacin inicijalizovali nasledjen podobjekat klase Usluga
	Poziv(const Broj&, const Broj&, int);

	virtual double cena() const override;
	virtual void pisi() const override;

private:
	int trajanje_;
};

const int porukaDom = 3;
const int porukaIno = 20;

class Poruka : public Usluga {
public:
	Poruka(const Broj&, const Broj&, const string&);

	virtual double cena() const override;
	virtual void pisi() const override;

private:
	string tekst_;
};

#endif